

int main(int argc, char* argv[])
{
   
  const int INFINITY = 2000000000;

  //  Nie dziala, p jest wskaznikiem na liczbe ktora jest stala. Nie mozna jej zmieniac
  //int* p = &INFINITY;

  // Definiujemy wskaznik na stala. To, na co wskazuje ten wskaznik trzeba traktowac jak stala .
  const int* p1 = &INFINITY;
  int const* p2 = &INFINITY;
  // Tak nie mozna
  // *p1=8;
  //*p2 = 7;

  //Oczywiscie elementem wskazywanym nie musi koniecznie byc stala. 
  //Wazne jest niemodyfikowanie zawartosci elementow: 
  int x = 42;
  const int* p3 = &x;
  // Wtedy tak mozna:
  x=43;
  // Tak nie mozna
  //*p3=4;
  // Tak można, zmieniam adres.
  p3 = new int(8); 

  //Kiedy const pojawia sie po gwiazdce, to mamy staly wskaznik. 
  // Czyli mozemy modyfikowac element, na ktory wskazuje p, ale nie mozemy zmienic samego p - 
  // ten wskaznik bedzie juz zawsze wskazywal na ten sam adres w pamieci.
  int y = 42;
  int* const p4 = &y;
  *p4=8;
  // Nie mozna
  //p4 = new int(8); 

  //W ponizszym przykladzie nie mozemy zmieniac zarowno tego na co wskazuje p4, jak i samego wskaznika
  const int* const p5 = &INFINITY;
  // Nie mozna:
  //p5 = new int(8); 
  //*p5=8;

  // Jest OK. p6 nie jest stala 
  int p6 = INFINITY;
  p6=8;


  const int p7 = INFINITY;
  // Blad. p7 jest jest stala 
  //p7=8;

  // Referencja do stalej
  const int& r = INFINITY;
  int const& r1 = INFINITY;

  // Tak nie mozna
  //r = 7;

  return 0;
}