#include <iostream>

class Wektor
{
private:
    double x;
    double y;

public:
    Wektor()
    {
        this->x = 0;
        this->y = 0;
    }
    Wektor( double x, double y )
    {
        this->x = x;
        this->y = y;
    }

	// Operator wypisywania wektora
	friend std::ostream& operator<< (std::ostream &wyjscie, Wektor const& ex)
	{
	   wyjscie << "x: " << ex.x << " y: " << ex.y << std::endl;
	   return wyjscie;
	}

	// Dodawanie liczby do wektora
	Wektor operator+ (int const& liczba)
	{    	
		Wektor tmp(x + liczba, y + liczba);
		return tmp;    
	}

	// Dodawanie dwoch wektorow
	Wektor operator+ (Wektor const& liczba) 
	{    
	   Wektor tmp(x + liczba.x, y + liczba.y);
	   return tmp;    
	}


	// Dodawanie liczby do wektora (liczba+wektor)
	// Metoda spoza klasy. Musi byc friend zeby byl dostep do prywatnych x i y
	friend Wektor operator+ (int const& liczba, Wektor const& liczba1) 
	{       
	   Wektor tmp(liczba + liczba1.x, liczba + liczba1.y);
	   return tmp;    
	}

	// Przeladowanie operatora !
	Wektor operator !()
	{
		return Wektor( - this->x, - this->y );
	}

	// Przeladowanie operatora ==
	bool operator ==(Wektor const& liczba2)
	{
		if (this->x == liczba2.x && this->y == liczba2.y)
			return 1;

		return 0;
	}

};




int main(int argc, char* argv[])
{
	Wektor a(1,1), b(2,2);
	Wektor c, d, e, f;

	std::cout << "Wektor a: " << a << std::endl;

	// Wywolana bedzie metoda: Wektor operator+ (int const& liczba)
	c = a+3;
	std::cout << "Wektor c: " << c << std::endl; 

	// Wywolana bedzie metoda: Wektor operator+ (Wektor const& liczba) 
	d = a+b;
	std::cout << "Wektor d: " << d << std::endl; 

	// Wywolana bedzie metoda: friend Wektor operator+ (int const& liczba, Wektor const& liczba1)
	e = 4+a;
	std::cout << "Wektor e: " << e << std::endl;

	f=a+1;
	std::cout << "Wektor f: " << f << std::endl;

    if (f==b)
	    std::cout << "Liczby rowne" << std::endl;

	a=!a;
	std::cout << "Wektor !a: " << a << std::endl; 
 
  return 0;
}
